import { IContext, ICommandMapper, ICommandUnmapper } from "@robotlegsjs/core";
import { ISignalCommandMap } from "../api/ISignalCommandMap";
/**
 * @private
 */
export declare class SignalCommandMap implements ISignalCommandMap {
    private _mappingProcessors;
    private _injector;
    private _triggerMap;
    private _logger;
    /**
     * @private
     */
    constructor(context: IContext);
    /**
     * @inheritDoc
     */
    map(signalClass: Object): ICommandMapper;
    /**
     * @inheritDoc
     */
    unmap(signalClass: Object): ICommandUnmapper;
    addMappingProcessor(handler: Function): ISignalCommandMap;
    private createTrigger(signalClass);
    private getTrigger(signalClass);
    private getKey(signalClass);
}
