"use strict";
// ------------------------------------------------------------------------------
//  Copyright (c) 2017 RobotlegsJS. All Rights Reserved.
//
//  NOTICE: You are permitted to use, modify, and distribute this file
//  in accordance with the terms of the license agreement accompanying it.
// ------------------------------------------------------------------------------
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@robotlegsjs/core");
var SignalCommandTrigger_1 = require("./SignalCommandTrigger");
/**
 * @private
 */
var SignalCommandMap = /** @class */ (function () {
    /*============================================================================*/
    /* Constructor                                                                */
    /*============================================================================*/
    /**
     * @private
     */
    function SignalCommandMap(context) {
        /*============================================================================*/
        /* Private Properties                                                         */
        /*============================================================================*/
        this._mappingProcessors = [];
        this._injector = context.injector;
        this._logger = context.getLogger(this);
        this._triggerMap = new core_1.CommandTriggerMap(this.getKey, this.createTrigger.bind(this));
    }
    /*============================================================================*/
    /* Public Functions                                                           */
    /*============================================================================*/
    /**
     * @inheritDoc
     */
    SignalCommandMap.prototype.map = function (signalClass) {
        return this.getTrigger(signalClass).createMapper();
    };
    /**
     * @inheritDoc
     */
    SignalCommandMap.prototype.unmap = function (signalClass) {
        return this.getTrigger(signalClass).createMapper();
    };
    SignalCommandMap.prototype.addMappingProcessor = function (handler) {
        if (this._mappingProcessors.indexOf(handler) === -1) {
            this._mappingProcessors.push(handler);
        }
        return this;
    };
    /*============================================================================*/
    /* Private Functions                                                          */
    /*============================================================================*/
    SignalCommandMap.prototype.createTrigger = function (signalClass) {
        return new SignalCommandTrigger_1.SignalCommandTrigger(this._injector, signalClass, this._mappingProcessors);
    };
    SignalCommandMap.prototype.getTrigger = function (signalClass) {
        return this._triggerMap.getTrigger(signalClass);
    };
    SignalCommandMap.prototype.getKey = function (signalClass) {
        return signalClass;
    };
    SignalCommandMap = __decorate([
        core_1.injectable(),
        __param(0, core_1.inject(core_1.IContext)),
        __metadata("design:paramtypes", [Object])
    ], SignalCommandMap);
    return SignalCommandMap;
}());
exports.SignalCommandMap = SignalCommandMap;
//# sourceMappingURL=SignalCommandMap.js.map